Index: boot/arch/arm64/include/arch/types.h
===================================================================
--- boot/arch/arm64/include/arch/types.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ boot/arch/arm64/include/arch/types.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2015 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup boot_arm64
+ * @{
+ */
+/** @file
+ * @brief Definitions of basic types like #uintptr_t.
+ */
+
+#ifndef BOOT_arm64_TYPES_H
+#define BOOT_arm64_TYPES_H
+
+#include <_bits/all.h>
+
+#include <arch/boot.h>
+#define task_t utask_t
+
+#endif
+
+/** @}
+ */
Index: boot/arch/arm64/src/asm.S
===================================================================
--- boot/arch/arm64/src/asm.S	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ boot/arch/arm64/src/asm.S	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,166 @@
+/*
+ * Copyright (c) 2015 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <abi/asmtool.h>
+#include <arch/arch.h>
+#include <arch/regutils.h>
+
+.section BOOTSTRAP
+
+/* MS-DOS stub */
+msdos_stub:
+	.ascii "MZ"                     /* MS-DOS signature */
+	.space 0x3a                     /* Ignore fields up to byte at 0x3c */
+	.long pe_header - msdos_stub    /* Offset to the PE header */
+
+/* Portable Executable header */
+pe_header:
+	/* PE signature */
+	.ascii "PE\x0\x0"
+
+	/* COFF File Header */
+	.short 0xaa64                   /* Machine = IMAGE_FILE_MACHINE_ARM64 */
+	.short 1                        /* Number of sections */
+	.long 0                         /* Time date stamp */
+	.long 0                         /* Pointer to symbol table */
+	.long 0                         /* Number of symbols */
+	.short sec_table - opt_header   /* Size of optional header */
+	/* Characteristics = IMAGE_FILE_EXECUTABLE_IMAGE |
+	 *   IMAGE_FILE_LARGE_ADDRESS_AWARE */
+	.short 0x22
+
+	/* Optional header standard fields */
+opt_header:
+	.short 0x20b                    /* Magic = PE32+ */
+	.byte 0                         /* Major linker version */
+	.byte 0                         /* Minor linker version */
+	.long payload_end - msdos_stub  /* Size of code */
+	.long 0                         /* Size of initialized data */
+	.long 0                         /* Size of uninitialized data */
+	.long start - msdos_stub        /* Address of entry point */
+	.long start - msdos_stub        /* Base of code */
+
+	/* Optional header Windows-specific fields */
+	.quad 0                         /* Image base */
+	.long 4                         /* Section alignment */
+	.long 4                         /* File alignment */
+	.short 0                        /* Major operating system version */
+	.short 0                        /* Minor operating system version */
+	.short 0                        /* Major image version */
+	.short 0                        /* Minor image version */
+	.short 0                        /* Major subsystem version */
+	.short 0                        /* Minor subsystem version */
+	.long 0                         /* Win32 version value */
+	.long payload_end - msdos_stub  /* Size of image */
+	.long start - msdos_stub        /* Size of headers */
+	.long 0                         /* Checksum */
+	.short 10                       /* Subsystem = EFI application */
+	.short 0                        /* DLL characteristics */
+	.quad 0                         /* Size of stack reserve */
+	.quad 0                         /* Size of stack commit */
+	.quad 0                         /* Size of heap reserve */
+	.quad 0                         /* Size of heap commit */
+	.long 0                         /* Loader flags */
+	.long 0                         /* Number of RVA and sizes */
+
+sec_table:
+        .ascii ".text\x0\x0\x0"         /* Name */
+	.long payload_end - start       /* Virtual size */
+	.long start - msdos_stub        /* Virtual address */
+	.long payload_end - start       /* Size of raw data */
+	.long start - msdos_stub        /* Pointer to raw data */
+	.long 0                         /* Pointer to relocations */
+	.long 0                         /* Pointer to line numbers */
+	.short 0                        /* Number of relocations */
+	.short 0                        /* Number of line numbers */
+	/* Characteristics = IMAGE_SCN_CNT_CODE | IMAGE_SCN_MEM_EXECUTE |
+	 *   IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_WRITE */
+	.long 0xe0000020
+
+SYMBOL(start)
+	.hidden start
+
+	/*
+	 * Parameters:
+	 * x0 is the image handle.
+	 * x1 is a pointer to the UEFI system table.
+	 */
+
+	/*
+	 * Stay on the UEFI stack. Its size is at least 128 kB, plenty for this
+	 * boot loader.
+	 */
+	stp x29, x30, [sp, #-32]!
+	mov x29, sp
+	stp x0, x1, [sp, #16]
+
+	/*
+	 * Self-relocate the image. Pass a load address of the image (x0) and a
+	 * pointer to the dynamic array (x1).
+	 */
+	adr x0, msdos_stub
+	adrp x1, _DYNAMIC
+	add x1, x1, #:lo12:_DYNAMIC
+	bl self_relocate
+	cbnz x0, 0f
+
+	/*
+	 * Pass the image handle (x0), a pointer to the UEFI system table (x1),
+	 * and the image load address (x2) to the boostrap function.
+	 */
+	ldp x0, x1, [sp, #16]
+	adr x2, msdos_stub
+	bl bootstrap
+
+0:
+	ldp x29, x30, [sp], #32
+	ret
+
+FUNCTION_BEGIN(halt)
+	.hidden halt
+
+	b halt
+FUNCTION_END(halt)
+
+FUNCTION_BEGIN(jump_to_kernel)
+	.hidden jump_to_kernel
+
+	/*
+	 * Parameters:
+	 * x0 is kernel entry point.
+	 * x1 is pointer to the bootinfo structure.
+	 */
+
+	/* Disable MMU (removes the identity mapping provided by UEFI). */
+	mrs x2, sctlr_el1
+	bic x2, x2, #SCTLR_M_FLAG
+	msr sctlr_el1, x2
+	isb
+
+	br x0
+FUNCTION_END(jump_to_kernel)
Index: boot/arch/arm64/src/main.c
===================================================================
--- boot/arch/arm64/src/main.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ boot/arch/arm64/src/main.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,326 @@
+/*
+ * Copyright (c) 2015 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup boot_arm64
+ * @{
+ */
+/** @file
+ * @brief Bootstrap.
+ */
+
+#include <stddef.h>
+#include <align.h>
+#include <arch/arch.h>
+#include <arch/asm.h>
+#include <arch/barrier.h>
+#include <arch/main.h>
+#include <arch/regutils.h>
+#include <arch/types.h>
+#include <errno.h>
+#include <inflate.h>
+#include <kernel.h>
+#include <macros.h>
+#include <memstr.h>
+#include <payload.h>
+#include <printf.h>
+#include <putchar.h>
+#include <str.h>
+#include <version.h>
+
+static efi_system_table_t *efi_system_table;
+
+/** Translate given UEFI memory type to the bootinfo memory type.
+ *
+ * @param type UEFI memory type.
+ */
+static memtype_t get_memtype(uint32_t type)
+{
+	switch (type) {
+	case EFI_RESERVED:
+	case EFI_RUNTIME_SERVICES_CODE:
+	case EFI_RUNTIME_SERVICES_DATA:
+	case EFI_UNUSABLE_MEMORY:
+	case EFI_ACPI_MEMORY_NVS:
+	case EFI_MEMORY_MAPPED_IO:
+	case EFI_MEMORY_MAPPED_IO_PORT_SPACE:
+	case EFI_PAL_CODE:
+		return MEMTYPE_UNUSABLE;
+	case EFI_LOADER_CODE:
+	case EFI_LOADER_DATA:
+	case EFI_BOOT_SERVICES_CODE:
+	case EFI_BOOT_SERVICES_DATA:
+	case EFI_CONVENTIONAL_MEMORY:
+	case EFI_PERSISTENT_MEMORY:
+		return MEMTYPE_AVAILABLE;
+	case EFI_ACPI_RECLAIM_MEMORY:
+		return MEMTYPE_ACPI_RECLAIM;
+	}
+
+	return MEMTYPE_UNUSABLE;
+}
+
+/** Send a byte to the UEFI console output.
+ *
+ * @param byte Byte to send.
+ */
+static void scons_sendb(uint8_t byte)
+{
+	int16_t out[2] = { byte, '\0' };
+	efi_system_table->cons_out->output_string(efi_system_table->cons_out,
+	    out);
+}
+
+/** Display a character.
+ *
+ * @param ch Character to display.
+ */
+void putwchar(wchar_t ch)
+{
+	if (ch == '\n')
+		scons_sendb('\r');
+
+	if (ascii_check(ch))
+		scons_sendb((uint8_t) ch);
+	else
+		scons_sendb('?');
+}
+
+efi_status_t bootstrap(void *efi_handle_in,
+    efi_system_table_t *efi_system_table_in, void *load_address)
+{
+	efi_status_t status;
+	uint64_t current_el;
+	uint64_t memmap = 0;
+	sysarg_t memmap_size;
+	sysarg_t memmap_key;
+	sysarg_t memmap_descriptor_size;
+	uint32_t memmap_descriptor_version;
+	uint64_t alloc_addr = 0;
+	sysarg_t alloc_pages = 0;
+
+	/*
+	 * Bootinfo structure is dynamically allocated in the ARM64 port. It is
+	 * placed directly after the inflated components. This assures that if
+	 * the kernel identity maps the first gigabyte of the main memory in the
+	 * kernel/upper address space then it can access the bootinfo because
+	 * the inflated components and bootinfo can always fit in this area.
+	 */
+	bootinfo_t *bootinfo;
+
+	efi_system_table = efi_system_table_in;
+
+	version_print();
+
+	printf("Boot loader: %p -> %p\n", loader_start, loader_end);
+	printf("\nMemory statistics\n");
+	printf(" %p|%p: loader\n", load_address, load_address);
+	printf(" %p|%p: UEFI system table\n", efi_system_table_in,
+	    efi_system_table_in);
+
+	/* Validate the exception level. */
+	current_el = CurrentEL_read();
+	if (current_el != CURRENT_EL_EL1) {
+		printf("Error: Unexpected CurrentEL value %0#18" PRIx64 ".\n",
+		    current_el);
+		status = EFI_UNSUPPORTED;
+		goto fail;
+	}
+
+	/* Obtain memory map. */
+	status = efi_get_memory_map(efi_system_table, &memmap_size,
+	    (efi_v1_memdesc_t **) &memmap, &memmap_key, &memmap_descriptor_size,
+	    &memmap_descriptor_version);
+	if (status != EFI_SUCCESS) {
+		printf("Error: Unable to obtain initial memory map, status "
+		    "code: %" PRIx64 ".\n", status);
+		goto fail;
+	}
+
+	/* Find start of usable RAM. */
+	uint64_t memory_base = (uint64_t) -1;
+	for (sysarg_t i = 0; i < memmap_size / memmap_descriptor_size; i++) {
+		efi_v1_memdesc_t *desc = (void *) memmap +
+		    (i * memmap_descriptor_size);
+		if (get_memtype(desc->type) != MEMTYPE_AVAILABLE ||
+		    !(desc->attribute & EFI_MEMORY_WB))
+			continue;
+
+		if (desc->phys_start < memory_base)
+			memory_base = desc->phys_start;
+	}
+
+	/* Deallocate memory holding the map. */
+	efi_system_table->boot_services->free_pool((void *) memmap);
+	memmap = 0;
+
+	if (memory_base == (uint64_t) -1) {
+		printf("Error: Memory map does not contain any usable RAM.\n");
+		status = EFI_UNSUPPORTED;
+		goto fail;
+	}
+
+	/*
+	 * Check that everything is aligned on a 4kB boundary and the kernel can
+	 * be placed by the decompression code at a correct address.
+	 */
+
+	/* Statically check PAGE_SIZE and BOOT_OFFSET. */
+	_Static_assert(PAGE_SIZE == 4096, "PAGE_SIZE must be equal to 4096");
+	_Static_assert(IS_ALIGNED(BOOT_OFFSET, PAGE_SIZE),
+	    "BOOT_OFFSET must be a multiple of PAGE_SIZE");
+
+	/*
+	 * Dynamically check the memory base. The condition should be always
+	 * true because UEFI guarantees each physical/virtual address in the
+	 * memory map is aligned on a 4kB boundary.
+	 */
+	if (!IS_ALIGNED(memory_base, PAGE_SIZE)) {
+		printf("Error: Start of usable RAM (%p) is not aligned on a "
+		    "4kB boundary.\n", (void *) memory_base);
+		status = EFI_UNSUPPORTED;
+		goto fail;
+	}
+
+	/*
+	 * Calculate where the components (including the kernel) will get
+	 * placed.
+	 */
+	uint64_t decompress_base = memory_base + BOOT_OFFSET;
+	printf(" %p|%p: kernel entry point\n", (void *) decompress_base,
+	    (void *) decompress_base);
+
+	/*
+	 * Allocate memory for the decompressed components and for the bootinfo.
+	 */
+	uint64_t component_pages =
+	    ALIGN_UP(payload_unpacked_size(), EFI_PAGE_SIZE) / EFI_PAGE_SIZE;
+	uint64_t bootinfo_pages = ALIGN_UP(sizeof(*bootinfo), EFI_PAGE_SIZE) /
+	    EFI_PAGE_SIZE;
+	alloc_pages = component_pages + bootinfo_pages;
+	alloc_addr = decompress_base;
+	status = efi_system_table->boot_services->allocate_pages(
+	    EFI_ALLOCATE_ADDRESS, EFI_LOADER_CODE, alloc_pages, &alloc_addr);
+	if (status != EFI_SUCCESS) {
+		printf("Error: Unable to allocate memory for inflated "
+		    "components and bootinfo, status code: %" PRIx64 ".\n",
+		    status);
+		goto fail;
+	}
+
+	bootinfo = (void *) alloc_addr + component_pages * EFI_PAGE_SIZE;
+	printf(" %p|%p: boot info structure\n", bootinfo, bootinfo);
+	memset(bootinfo, 0, sizeof(*bootinfo));
+
+	/* Decompress the components. */
+	uint8_t *kernel_dest = (uint8_t *) alloc_addr;
+	uint8_t *ram_end = kernel_dest + component_pages * EFI_PAGE_SIZE;
+
+	extract_payload(&bootinfo->taskmap, kernel_dest, ram_end,
+	    (uintptr_t) kernel_dest, ensure_visibility);
+
+	/* Get final memory map. */
+	status = efi_get_memory_map(efi_system_table, &memmap_size,
+	    (efi_v1_memdesc_t **) &memmap, &memmap_key, &memmap_descriptor_size,
+	    &memmap_descriptor_version);
+	if (status != EFI_SUCCESS) {
+		printf("Error: Unable to obtain final memory map, status code: "
+		    "%" PRIx64 ".\n", status);
+		goto fail;
+	}
+
+	/* Convert the UEFI memory map to the bootinfo representation. */
+	size_t cnt = 0;
+	memtype_t current_type = MEMTYPE_UNUSABLE;
+	void *current_start = 0;
+	size_t current_size = 0;
+	sysarg_t memmap_items_count = memmap_size / memmap_descriptor_size;
+	for (sysarg_t i = 0; i < memmap_items_count; i++) {
+		efi_v1_memdesc_t *desc = (void *) memmap +
+		    (i * memmap_descriptor_size);
+
+		/* Get type of the new area. */
+		memtype_t type;
+		if (!(desc->attribute & EFI_MEMORY_WB))
+			type = MEMTYPE_UNUSABLE;
+		else
+			type = get_memtype(desc->type);
+
+		/* Try to merge the new area with the previous one. */
+		if (type == current_type &&
+		    (uint64_t)current_start + current_size == desc->phys_start) {
+			current_size += desc->pages * EFI_PAGE_SIZE;
+			if (i != memmap_items_count - 1)
+				continue;
+		}
+
+		/* Record the previous area. */
+		if (current_type != MEMTYPE_UNUSABLE) {
+			if (cnt >= MEMMAP_MAX_RECORDS) {
+				printf("Error: Too many usable memory "
+				    "areas.\n");
+				status = EFI_UNSUPPORTED;
+				goto fail;
+			}
+			bootinfo->memmap.zones[cnt].type = current_type;
+			bootinfo->memmap.zones[cnt].start = current_start;
+			bootinfo->memmap.zones[cnt].size = current_size;
+			cnt++;
+		}
+
+		/* Remember the new area. */
+		current_type = type;
+		current_start = (void *) desc->phys_start;
+		current_size = desc->pages * EFI_PAGE_SIZE;
+	}
+	bootinfo->memmap.cnt = cnt;
+
+	uintptr_t entry = check_kernel_translated((void *) decompress_base,
+	    BOOT_OFFSET);
+
+	printf("Booting the kernel...\n");
+
+	/* Exit boot services. This is a point of no return. */
+	efi_system_table->boot_services->exit_boot_services(efi_handle_in,
+	    memmap_key);
+
+	entry = memory_base + KA2PA(entry);
+	jump_to_kernel((void *) entry, bootinfo);
+
+fail:
+	if (memmap != 0)
+		efi_system_table->boot_services->free_pool((void *) memmap);
+
+	if (alloc_addr != 0)
+		efi_system_table->boot_services->free_pages(alloc_addr,
+		    alloc_pages);
+
+	return status;
+}
+
+/** @}
+ */
Index: boot/arch/arm64/src/relocate.c
===================================================================
--- boot/arch/arm64/src/relocate.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ boot/arch/arm64/src/relocate.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 2019 Petr Pavlu
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup boot_arm64
+ * @{
+ */
+/** @file
+ * @brief Image self-relocation support.
+ */
+
+#include <arch/relocate.h>
+#include <printf.h>
+
+/** Self-relocate the bootloader.
+ *
+ * Note: This code is responsible for self-relocating the bootloader when it is
+ * started. As such, it is required that it is written in a way that it itself
+ * does not need any dynamic relocation.
+ */
+efi_status_t self_relocate(uintptr_t base, const elf_dyn_t *dyn)
+{
+	const elf_rela_t *rela = NULL;
+	uint64_t relasz = 0;
+	uint64_t relaent = 0;
+
+	/* Parse the dynamic array. */
+	while (dyn->d_tag != DT_NULL) {
+		switch (dyn->d_tag) {
+		case DT_RELA:
+			rela = (const elf_rela_t *) (base + dyn->d_un.d_ptr);
+			break;
+		case DT_RELASZ:
+			relasz = dyn->d_un.d_val;
+			break;
+		case DT_RELAENT:
+			relaent = dyn->d_un.d_val;
+			break;
+		}
+		dyn++;
+	}
+
+	/* Validate obtained information. */
+	if (rela == NULL)
+		return EFI_SUCCESS;
+	if (relaent == 0 || relasz % relaent != 0)
+		return EFI_UNSUPPORTED;
+
+	/* Process relocations in the image. */
+	while (relasz > 0) {
+		switch (ELF_R_TYPE(rela->r_info)) {
+		case R_AARCH64_RELATIVE:
+			*(uint64_t *) (base + rela->r_offset) =
+			    base + rela->r_addend;
+			break;
+		default:
+			return EFI_UNSUPPORTED;
+		}
+
+		rela = (const elf_rela_t *) ((const char *) rela + relaent);
+		relasz -= relaent;
+	}
+	return EFI_SUCCESS;
+}
+
+/** @}
+ */
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/ia64/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -29,5 +29,4 @@
 BFD_NAME = elf64-ia64-little
 BFD_OUTPUT = $(BFD_NAME)
-BFD_ARCH = ia64
 
 BITS = 64
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/mips32/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -27,5 +27,4 @@
 #
 
-BFD_ARCH = mips
 BITS = 32
 EXTRA_CFLAGS = -msoft-float -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mabi=32
@@ -54,8 +53,10 @@
 	RD_DRVS_ESSENTIAL += \
 		platform/malta \
+		intctl/i8259 \
 		block/ata_bd \
 		bus/pci/pciintel \
 		bus/isa \
 		char/i8042 \
+		char/ns8250 \
 		hid/ps2mouse \
 		hid/xtkbd
Index: boot/arch/mips32/include/arch/main.h
===================================================================
--- boot/arch/mips32/include/arch/main.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/mips32/include/arch/main.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -30,5 +30,5 @@
 #define BOOT_mips32_MAIN_H_
 
-extern void bootstrap(void);
+extern void bootstrap(int, char **);
 
 #endif
Index: boot/arch/mips32/include/arch/types.h
===================================================================
--- boot/arch/mips32/include/arch/types.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/mips32/include/arch/types.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -35,4 +35,5 @@
 #define CPUMAP_MAX_RECORDS         32
 #define BOOTINFO_TASK_NAME_BUFLEN  32
+#define BOOTINFO_BOOTARGS_BUFLEN   256
 
 typedef struct {
@@ -56,4 +57,5 @@
 	uint32_t cpumap;
 	taskmap_t taskmap;
+	char bootargs[BOOTINFO_BOOTARGS_BUFLEN];
 } bootinfo_t;
 
Index: boot/arch/mips32/src/asm.S
===================================================================
--- boot/arch/mips32/src/asm.S	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/mips32/src/asm.S	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -36,4 +36,15 @@
 .section BOOTSTRAP
 
+/*
+ * Registers on entry:
+ *
+ *   a0: kernel argument count (kargc)
+ *   a1: kernel argument vector (kargv) of kargc elements
+ *   a2: unused here (kenvp on Malta)
+ *   a3: RAM size on Malta
+ *
+ * This is the case on Malta.
+ * msim clears these registers, so it is de facto correct as well.
+ */
 SYMBOL(start)
 	/*
@@ -43,8 +54,8 @@
 	 *  - Disable 64-bit user addressing mode
 	 */
-	mfc0 $a0, $status
-	la $a1, 0xffffff1f
-	and $a0, $a1, $a0
-	mtc0 $a0, $status
+	mfc0 $t0, $status
+	la $t1, 0xffffff1f
+	and $t0, $t1, $t0
+	mtc0 $t0, $status
 
 #if defined(MACHINE_lmalta) || defined(MACHINE_bmalta)
@@ -52,6 +63,6 @@
 	 * Remember the size of the SDRAM in bootinfo.
 	 */
-	la $a0, PA2KA(BOOTINFO_OFFSET)
-	sw $a3, 0($a0)
+	la $t0, PA2KA(BOOTINFO_OFFSET)
+	sw $a3, 0($t0)
 #endif
 
@@ -61,47 +72,47 @@
 	 * but it not an issue).
 	 */
-	la $a0, PA2KA(CPUMAP_OFFSET)
+	la $t0, PA2KA(CPUMAP_OFFSET)
 
-	sw $zero, 0($a0)
-	sw $zero, 4($a0)
-	sw $zero, 8($a0)
-	sw $zero, 12($a0)
+	sw $zero, 0($t0)
+	sw $zero, 4($t0)
+	sw $zero, 8($t0)
+	sw $zero, 12($t0)
 
-	sw $zero, 16($a0)
-	sw $zero, 20($a0)
-	sw $zero, 24($a0)
-	sw $zero, 28($a0)
+	sw $zero, 16($t0)
+	sw $zero, 20($t0)
+	sw $zero, 24($t0)
+	sw $zero, 28($t0)
 
-	sw $zero, 32($a0)
-	sw $zero, 36($a0)
-	sw $zero, 40($a0)
-	sw $zero, 44($a0)
+	sw $zero, 32($t0)
+	sw $zero, 36($t0)
+	sw $zero, 40($t0)
+	sw $zero, 44($t0)
 
-	sw $zero, 48($a0)
-	sw $zero, 52($a0)
-	sw $zero, 56($a0)
-	sw $zero, 60($a0)
+	sw $zero, 48($t0)
+	sw $zero, 52($t0)
+	sw $zero, 56($t0)
+	sw $zero, 60($t0)
 
-	sw $zero, 64($a0)
-	sw $zero, 68($a0)
-	sw $zero, 72($a0)
-	sw $zero, 76($a0)
+	sw $zero, 64($t0)
+	sw $zero, 68($t0)
+	sw $zero, 72($t0)
+	sw $zero, 76($t0)
 
-	sw $zero, 80($a0)
-	sw $zero, 84($a0)
-	sw $zero, 88($a0)
-	sw $zero, 92($a0)
+	sw $zero, 80($t0)
+	sw $zero, 84($t0)
+	sw $zero, 88($t0)
+	sw $zero, 92($t0)
 
-	sw $zero, 96($a0)
-	sw $zero, 100($a0)
-	sw $zero, 104($a0)
-	sw $zero, 108($a0)
+	sw $zero, 96($t0)
+	sw $zero, 100($t0)
+	sw $zero, 104($t0)
+	sw $zero, 108($t0)
 
-	sw $zero, 112($a0)
-	sw $zero, 116($a0)
-	sw $zero, 120($a0)
-	sw $zero, 124($a0)
+	sw $zero, 112($t0)
+	sw $zero, 116($t0)
+	sw $zero, 120($t0)
+	sw $zero, 124($t0)
 
-	lui $a1, 1
+	lui $t1, 1
 
 #ifdef MACHINE_msim
@@ -119,7 +130,7 @@
 
 	/* Record CPU presence */
-	sll $a2, $k1, 2
-	addu $a2, $a2, $a0
-	sw $a1, ($a2)
+	sll $t2, $k1, 2
+	addu $t2, $t2, $t0
+	sw $t1, ($t2)
 
 	loop:
@@ -131,9 +142,10 @@
 	bsp:
 		/* Record CPU presence */
-		sw $a1, ($a0)
+		sw $t1, ($t0)
 
 		/* Setup initial stack */
 		la $sp, PA2KA(STACK_OFFSET)
 
+		/* a0=kargc, a1=kargv */
 		j bootstrap
 		nop
Index: boot/arch/mips32/src/main.c
===================================================================
--- boot/arch/mips32/src/main.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/mips32/src/main.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -45,5 +45,5 @@
 static uint32_t *cpumap = (uint32_t *) PA2KA(CPUMAP_OFFSET);
 
-void bootstrap(void)
+void bootstrap(int kargc, char **kargv)
 {
 	version_print();
@@ -79,4 +79,7 @@
 	}
 
+	str_cpy(bootinfo->bootargs, sizeof(bootinfo->bootargs),
+	    (kargc > 1) ? kargv[1] : "");
+
 	uintptr_t entry = check_kernel(kernel_start);
 
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/ppc32/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -33,12 +33,8 @@
 BFD_NAME = elf32-powerpc
 BFD_OUTPUT = $(BFD_NAME)
-BFD_ARCH = powerpc:common
 
 BITS = 32
 ENDIANESS = BE
 EXTRA_CFLAGS = -mcpu=powerpc -msoft-float -m32
-
-RD_SRVS_ESSENTIAL += \
-	hw/bus/cuda_adb
 
 RD_DRVS_ESSENTIAL += \
Index: boot/arch/riscv64/Makefile.inc
===================================================================
--- boot/arch/riscv64/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/riscv64/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -29,5 +29,4 @@
 BFD_NAME = elf64-littleriscv
 BFD_OUTPUT = $(BFD_NAME)
-BFD_ARCH = riscv
 
 BITS = 64
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/arch/sparc64/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -33,5 +33,4 @@
 BFD_NAME = elf64-sparc
 BFD_OUTPUT = $(BFD_NAME)
-BFD_ARCH = sparc
 
 BITS = 64
Index: boot/doc/doxygroups.h
===================================================================
--- boot/doc/doxygroups.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ boot/doc/doxygroups.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -11,2 +11,6 @@
  *     @ingroup boot
  */
+
+/**    @addtogroup boot_arm64 arm64
+ *     @ingroup boot
+ */
